from django.urls import path, re_path

from .views import (
    IssuesSnippet,
    ModuleDeploymentsView,
    ModuleDiffView,
    ModuleIssuesView,
    ModulesView,
    ProjectDetailView,
    ProjectHistoryView,
    ProjectSummaryHistoryView,
    api_issues_json,
    module_deployments_json,
)

urlpatterns = [
    path('modules/', ModulesView.as_view(), name='modules-list'),
    re_path(r'^(?P<slug>[\w,-]+)/$', ProjectDetailView.as_view(), name='project-view'),
    re_path(
        r'^(?P<slug>[\w,-]+)/history$', ProjectSummaryHistoryView.as_view(), name='project-summary-history'
    ),
    re_path(r'^(?P<slug>[\w,-]+)/detailed-history$', ProjectHistoryView.as_view(), name='project-history'),
    re_path(
        r'^modules/(?P<name>[\w,-]+)/diff/(?P<commit1>[\w,\.-]+)/(?P<commit2>[\w,\.-]+)$',
        ModuleDiffView.as_view(),
        name='module-diff',
    ),
    path('issues/snippet/', IssuesSnippet.as_view(), name='issues-snippet'),
    re_path(
        r'^modules/(?P<name>[\w,-]+)/issues/(?P<commit1>[\w,\.-]+)/(?P<commit2>[\w,\.-]+)$',
        ModuleIssuesView.as_view(),
        name='module-issues',
    ),
    re_path(r'^modules/(?P<name>[\w,-]+)/$', ModuleDeploymentsView.as_view(), name='module-deployments'),
    re_path(r'^modules/(?P<name>[\w,-]+)/json$', module_deployments_json, name='module-deployments-json'),
    path('api/issues/<int:issue>/', api_issues_json),
]
